<?php
function mlw_qmn_generate_leaderboard_settings()
{
	$variables =  apply_filters('qmn_leaderboard_template_variables', array(
		'rank' => 'Rank',
		'quiz_name' => 'QUIZ NAME',
		'user_business' => 'User Business',
		'user_name' => 'USER NAME',
		'correct_score' => 'CORRECT SCORE',
		'point_score' => 'POINT SCORE',
		'time_taken' => 'TIME TAKEN',
		'time_taken_ms' => 'TIME TAKEN IN Millisecond',
		'amount_correct' => 'AMOUNT CORRECT',
		'total_questions' => 'TOTAL QUESTIONS',
		'date' => 'DATE',
		)
	);
	$mlw_qmn_al_options = get_option('mlw_qmn_al_option');
	$enable_variables = isset( $mlw_qmn_al_options['variables'] ) ? $mlw_qmn_al_options['variables'] : array();
	?>
	<style type="text/css">
		div.mlw_quiz_options input[type='text'], div.mlw_quiz_options textarea{border-color:#000000;color:#3300CC;cursor:hand;}
	</style>
	<div class="wrap">
	<div class='mlw_quiz_options'>
	<h2><?php _e( 'QMN Advanced Leaderboards', 'qsm-advanced-leaderboard' ); ?> </h2>
	<form method="post" action="options.php">
		<?php settings_fields('mlw_qmn_al_settings'); ?>
		<p><?php
         _e( 'There are 4 shortcodes with this add-on. Ranks is the amount of results you want in the leaderboard. Mlw_quiz is the quiz number of the quiz you want in the leaderboard.', 'qsm-advanced-leaderboard' );
		 _e( 'Name is the title of the leaderboard. For those using the points system, you must include max_points=0 in your shortcode where 0 is the maximum amount of points a user can receive in the quiz.', 'qsm-advanced-leaderboard' );
         _e( 'Lastly, set order to score to order the leaderboard by highest score first or set it to latest to order the leaderboard by most recent first.', 'qsm-advanced-leaderboard' );
		?> </p>
		<p><?php _e( 'The first shortcode is to show a leaderboard for all quizzes:', 'qsm-advanced-leaderboard' ); ?>  <code>[mlw_qmn_all_leaderboard ranks=4 name='Title' order='latest']</code></p>
		<p><?php _e( 'The next shortcode is to show a leaderboard for one quizzes:', 'qsm-advanced-leaderboard' ); ?>  <code>[mlw_qmn_single_leaderboard mlw_quiz=1 ranks=4 name='Title' order='score']</code></p>
		<p><?php _e( 'The next shortcode is to show a graph for all quizzes:', 'qsm-advanced-leaderboard' ); ?> <code>[mlw_qmn_all_graph ranks=4 name='Title']</code></p>
		<p><?php _e( 'The last shortcode is to show a graph for one quizzes:', 'qsm-advanced-leaderboard' ); ?><code>[mlw_qmn_single_graph mlw_quiz=1 ranks=4 name='Title']</code></p>
		<table class="form-table">
			<tr>
				<td colspan="2">
					<h3 style="margin: 0;"><?php _e( 'Leaderboard Template', 'qsm-advanced-leaderboard' ); ?> </h3>
				</td>
			</tr>
			<tr>
				<td width="100%" colspan="2">
					<strong><?php _e( 'Display Variables', 'qsm-advanced-leaderboard' ); ?> </strong>
				</td>
			</tr>
			<?php foreach($variables as $key => $val) :?>
			<?php 
			$yes = $no = '';
			if ((isset($enable_variables[$key]) && $enable_variables[$key] == 'yes')) {
				$yes = 'checked="checked"';
			} else {
				$no = 'checked="checked"';
			}
			?>
			<tr>
				<td width="30%"><?php echo $val;?></td>
				<td>
					<label>
						<input type="radio" name="mlw_qmn_al_option[variables][<?php echo $key;?>]" value="yes" <?php echo $yes;?>>
						<span><?php _e( 'Enable', 'qsm-advanced-leaderboard' );?></span>
					</label>
					&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
					<label>
						<input type="radio" name="mlw_qmn_al_option[variables][<?php echo $key;?>]" value="no" <?php echo $no;?>>
						<span><?php _e( 'Disable', 'qsm-advanced-leaderboard' );?></span>
					</label>
				</td>
			</tr>
			<?php endforeach;?>
		</table>
		
		<table class="form-table">
			<tr>
				<td colspan="2">
					<h3 style="margin: 0;"><?php _e( 'Graph Template', 'qsm-advanced-leaderboard' ); ?> </h3>
				</td>
			</tr>
			<tr>
				<td width="30%">
					<strong><?php _e( 'Allowed Variables:', 'qsm-advanced-leaderboard' ); ?></strong>
					<br />
					<p style="margin: 2px 0">- %POINT_SCORE%</p>
					<p style="margin: 2px 0">- %CORRECT_SCORE%</p>
					<p style="margin: 2px 0">- %QUIZ_NAME%</p>
					<p style="margin: 2px 0">- %USER_NAME%</p>
					<p style="margin: 2px 0">- %TIME_TAKEN%</p>
					<p style="margin: 2px 0">- %TIME_TAKEN_MS%</p>
					<p style="margin: 2px 0">- %AMOUNT_CORRECT%</p>
					<p style="margin: 2px 0">- %TOTAL_QUESTIONS%</p>
				</td>
				<td><textarea cols="80" rows="3" id="mlw_qmn_al_option[template]" name="mlw_qmn_al_option[template]"><?php echo $mlw_qmn_al_options['template']; ?></textarea></td>
			</tr>
			<tr>
				<td width="30%">
					<strong><?php _e( 'Graph Color', 'qsm-advanced-leaderboard' ); ?> </strong>
				</td>
				<td><input type="text" id="mlw_qmn_al_option[graph_color]" name="mlw_qmn_al_option[graph_color]" value="<?php echo $mlw_qmn_al_options['graph_color']; ?>" />
				</td>
			</tr>
			<tr>
				<td width="30%">
					<strong><?php _e( 'Graph Font Color', 'qsm-advanced-leaderboard' ); ?> </strong>
				</td>
                                <td><input type="text" id="mlw_qmn_al_option[graph_font]" name="mlw_qmn_al_option[graph_font]" value="<?php echo isset( $mlw_qmn_al_options['graph_font'] ) ? $mlw_qmn_al_options['graph_font'] : ''; ?>" />
				</td>
			</tr>
        </table>
        <p class="submit">
        	<input type="submit" class="button-primary" value="<?php _e( 'Save Changes', 'qsm-advanced-leaderboard' ) ?>" />
        </p>
    </form>
	</div>
	</div>	
	<?php
}
