<?php
/**
 * qmn_leaderboard_template_variables_title
 */
function qsml_template_variables_title() {
	$titles = apply_filters('qmn_leaderboard_template_variables_title', array(
		'rank' => 'Rank',
		'quiz_name' => 'Quiz Name',
		'user_business' => 'User Business',
		'user_name' => 'User',
		'correct_score' => 'Correct Score',
		'point_score' => 'Point Score',
		'time_taken' => 'Time Taken',
		'time_taken_ms' => 'Time Taken',
		'amount_correct' => 'Amount Correct',
		'total_questions' => 'Total Questions',
		'date' => 'Date',
		)
	);
	return $titles;
}

/**
 * This function creates the leaderboard from the shortcode.
 */
function mlw_qmn_al_leaderboard_shortcode($atts) {
	extract(shortcode_atts(array(
		'mlw_quiz' => 1,
		'ranks' => 0,
		'name' => 'none',
		'order' => 'score'
	), $atts));
	$mlw_quiz_id = $mlw_quiz;
	global $wpdb;
	$mlw_quiz_options = $wpdb->get_row("SELECT * FROM `{$wpdb->prefix}mlw_quizzes` WHERE `quiz_id`='{$mlw_quiz_id}' AND `deleted`='0'");
	$serialize_options = isset($mlw_quiz_options->quiz_settings) ? unserialize($mlw_quiz_options->quiz_settings) : [];
	$quiz_options = isset($serialize_options['quiz_options']) ? unserialize($serialize_options['quiz_options']) : [];

	$mlw_order_sql = $mlw_limit_sql = '';
	
	if ($ranks != 0) {
		$mlw_limit_sql = " LIMIT {$ranks}";
	}
	switch ($order) {
		case 'date_asc':
			$mlw_order_sql .= " ORDER BY time_taken_real ASC";
			break;
		case 'date':
		case 'latest':
		case 'date_desc':
			$mlw_order_sql .= " ORDER BY time_taken_real DESC";
			break;
		case 'point_score':
			$mlw_order_sql .= " ORDER BY point_score DESC";			
			break;
		case 'point_score_asc':
			$mlw_order_sql .= " ORDER BY point_score ASC";
			break;
		case 'score_asc':
		case 'correct_score_asc':
			$mlw_order_sql = " ORDER BY correct_score ASC";
			break;
		default:
			$mlw_order_sql = " ORDER BY correct_score DESC";			
			break;
	}

	$mlw_result_data = $wpdb->get_results("SELECT * FROM " . $wpdb->prefix . "mlw_results WHERE `quiz_id`='{$mlw_quiz_id}' AND `deleted`='0' {$mlw_order_sql} {$mlw_limit_sql}");
	// $mlw_result_data = $wpdb->get_results("SELECT ".$wpdb->prefix."mlw_results.* , dense_rank()  
	// 	OVER ( partition by quiz_id {$mlw_order_sql}  ) AS 'dense_rank'
	// 	FROM " . $wpdb->prefix . "mlw_results WHERE `quiz_id`='{$mlw_quiz_id}' AND `deleted`='0' {$mlw_order_sql} {$mlw_limit_sql}");
	$data = $mlw_result_data;

	// echo "SELECT * FROM " . $wpdb->prefix . "mlw_results WHERE `quiz_id`='{$mlw_quiz_id}' AND `deleted`='0' {$mlw_order_sql} {$mlw_limit_sql}";

	/**
	 * Before Template Display Action
	 */
	do_action('qmn_leaderboard_template_before_single', $atts);

	$mlw_quiz_leaderboard_display = '';
	if ($name != 'none') {
		$mlw_quiz_leaderboard_display .= "<h2>" . $name . "</h2>";
	} else {
		$mlw_quiz_leaderboard_display .= "<h2>" . $mlw_quiz_options->quiz_name . "</h2>";
	}

	$mlw_quiz_leaderboard_display .= mlw_qmn_display_leaderboard_table($mlw_result_data, $order);

	return $mlw_quiz_leaderboard_display;
}

function mlw_qmn_al_all_leaderboard_shortcode($atts) {
	extract(shortcode_atts(array(
		'ranks' => 0,
		'name' => 'none',
		'order' => 'score'
	), $atts));
	$mlw_quiz_leaderboard_display = "";
	$mlw_order_sql = $mlw_limit_sql = '';
	if ($ranks != 0) {
		$mlw_limit_sql = " LIMIT $ranks";
	}
	switch ($order) {
		case 'date_asc':
			$mlw_order_sql .= " ORDER BY time_taken_real ASC";
			break;
		case 'date':
		case 'latest':
		case 'date_desc':
			$mlw_order_sql .= " ORDER BY time_taken_real DESC";
			break;
		case 'point_score':
			$mlw_order_sql .= " ORDER BY point_score DESC";
			break;
		case 'point_score_asc':
			$mlw_order_sql .= " ORDER BY point_score ASC";
			break;
		case 'score_asc':
		case 'correct_score_asc':
			$mlw_order_sql = " ORDER BY correct_score ASC";
			break;
		default:
			$mlw_order_sql = " ORDER BY correct_score DESC";
			break;
	}

	global $wpdb;
	$mlw_result_data = $wpdb->get_results("SELECT * FROM " . $wpdb->prefix . "mlw_results WHERE `deleted`='0' {$mlw_order_sql} {$mlw_limit_sql}");
	/**
	 * Before Template Display Action
	 */
	do_action('qmn_leaderboard_template_before_all', $atts);

	if ($name != 'none') {
		$mlw_quiz_leaderboard_display .= "<h2>" . $name . "</h2>";
	} else {
		$mlw_quiz_leaderboard_display .= "<h2>Quiz Scores</h2>";
	}

	$mlw_quiz_leaderboard_display .= mlw_qmn_display_leaderboard_table($mlw_result_data, $order);

	return $mlw_quiz_leaderboard_display;
}

function mlw_qmn_display_leaderboard_table($data = array(), $order = 'correct_score') {

	if (empty($data)) {
		return '';
	}
	$table_html = '';
	$mlw_qmn_al_options = get_option('mlw_qmn_al_option');
	$variables = isset($mlw_qmn_al_options['variables']) ? $mlw_qmn_al_options['variables'] : array();


	$variables_title = qsml_template_variables_title();


	foreach ($data as $key => $mlw_eaches) {
		$time_taken = $time_taken_ms = 0;
		$mlw_qmn_results_array = @unserialize($mlw_eaches->quiz_results);
		$mlw_complete_time = $mlw_complete_time_ms = '';
		if (is_array($mlw_qmn_results_array)) {
			$time_taken = $mlw_qmn_results_array[0];
			$time_taken_ms = ($time_taken * 1000);
			if (isset($mlw_qmn_results_array['timer_ms']) && $mlw_qmn_results_array['timer_ms'] > 0) {
				$time_taken_ms = $mlw_qmn_results_array['timer_ms'];
			}
		}
		$data[$key]->total_time_taken = $time_taken;
		// taking only milliseconds for old results
		$data[$key]->total_time_taken_ms = $time_taken_ms%1000;
	}
	switch ($order) {
		case 'date_asc':
			array_multisort(array_column($data, 'time_taken_real'), SORT_ASC, $data);
			break;
		case 'date':
		case 'latest':
		case 'date_desc':
			array_multisort(array_column($data, 'time_taken_real'), SORT_DESC, $data);
			break;
		case 'point_score':
			array_multisort(array_column($data, 'point_score'), SORT_DESC, array_column($data, 'total_time_taken'), SORT_ASC, array_column($data, 'total_time_taken_ms'), SORT_ASC, $data);
			break;
		case 'point_score_asc':
			array_multisort(array_column($data, 'point_score'), SORT_ASC, array_column($data, 'total_time_taken'), SORT_DESC, array_column($data, 'total_time_taken_ms'), SORT_DESC, $data);
			break;
		case 'time_taken':
			array_multisort(array_column($data, 'total_time_taken'), SORT_ASC, array_column($data, 'total_time_taken_ms'), SORT_ASC, $data);
			break;
		case 'time_taken_desc':
			array_multisort(array_column($data, 'total_time_taken'), SORT_DESC, array_column($data, 'total_time_taken_ms'), SORT_DESC, $data);
			break;
		case 'score_asc':
		case 'correct_score_asc':
			array_multisort(array_column($data, 'correct_score'), SORT_ASC, array_column($data, 'total_time_taken'), SORT_DESC, array_column($data, 'total_time_taken_ms'), SORT_DESC, $data);
			break;
		default:
			array_multisort(array_column($data, 'correct_score'), SORT_DESC, array_column($data, 'total_time_taken'), SORT_ASC, array_column($data, 'total_time_taken_ms'), SORT_ASC, $data);
			break;
	}

	if (!empty($variables)) {
		$qsml_table_head = $qsml_table_body = "";
		$i = 0;
		$dense_rank = 0;
		$dense_val = 0;
		$dense_array = array();
		$rank_req_score = 0;
		$rank_req_time = 0;
		$rank_ref = 0;
		$score = 0;
		foreach ($data as $mlw_eaches) {
			$quiz_results = @unserialize($mlw_eaches->quiz_results);
			$time =  $quiz_results['timer_ms'] / 1000 ;

			if($order == 'score_asc' || $order == 'score')
			{
				$dense_val = $mlw_eaches->correct_score;
			}
			else if($order == 'point_score_asc' || $order == 'point_score')
			{
				$dense_val = $mlw_eaches->point_score;
			}

			if($dense_rank != $dense_val)
			{
				$rank_req_values = mlw_qmn_get_rank($data , $dense_val , $order);
				$rank_req_score = $rank_req_values['required_score'];
				$rank_req_time = $rank_req_values['time_value'];
				$dense_rank = $dense_val;
				$rank_ref = $rank_ref + 1;
				
			}

			if($order == 'score_asc' || $order == 'score')
			{
				$score = $mlw_eaches->correct_score;
			}
			else if($order == 'point_score_asc' || $order == 'point_score')
			{
				$score = $mlw_eaches->point_score;
			}
			else
			{
				$score = $mlw_eaches->correct_score;
			}
			

			$qsml_table_body .= "<tr>";
			foreach ($variables as $key => $val) {
				if ($val == 'yes') {
					if ($i == 0) {
						$qsml_table_head .= "<th>{$variables_title[$key]}</th>";
					}
					$value = '';
					if($rank_req_score != $score || $rank_req_time != $time  )
					{	
						$rank_req_score = $score;
						$rank_req_time = $time;
						$rank_ref = $i+1;
					}
					switch ($key) {
						case 'rank':
							$value = $rank_ref;
							break;
						case 'user_name':
							$value = $mlw_eaches->name;
							break;
						case 'user_business':
							$value = $mlw_eaches->business;
							break;
						case 'time_taken':
						case 'time_taken_ms':
							$hrs = $mins = $secs = $ms = "";
							$time_taken = $mlw_eaches->total_time_taken;
							$mlw_complete_hours = floor($time_taken / 3600);
							if ($mlw_complete_hours > 0) {
								$hrs = "{$mlw_complete_hours} hr";
							}
							$mlw_complete_minutes = floor(($time_taken % 3600) / 60);
							if ($mlw_complete_minutes > 0) {
								$mins = "{$mlw_complete_minutes} min";
							}
							$mlw_complete_seconds = $time_taken % 60;
							//$mlw_complete_seconds = $time;
							$secs = "{$mlw_complete_seconds} sec";

							if ($key == 'time_taken_ms' && isset($mlw_eaches->total_time_taken_ms) && $mlw_eaches->total_time_taken_ms > 0) {
								$mlw_complete_ms = floor($mlw_eaches->total_time_taken_ms % 1000);
								if ($mlw_complete_ms > 0) {
									$mlw_complete_ms = str_pad($mlw_complete_ms, 3, "0", STR_PAD_LEFT);
									$ms = "$mlw_complete_ms ms";
								}
							}
							$value = "{$hrs} {$mins} {$secs} {$ms}";
							break;
						case 'amount_correct':
							$value = $mlw_eaches->correct;
							break;
						case 'total_questions':
							$value = $mlw_eaches->total;
							break;
						case 'date':
							$value = $mlw_eaches->time_taken_real;
							break;
						default:
							if (isset($mlw_eaches->$key)) {
								$value = $mlw_eaches->$key;
							}
							break;
					}
					$qsml_table_body .= "<td>{$value}</td>";
				}
			}
			$qsml_table_body .= "</tr>";
			$i++;
		}
		$table_html .= "<table class='quiz_leaderboard_wrapper'>";
		$table_html .= "<tr>{$qsml_table_head}</tr>";
		$table_html .= $qsml_table_body;
		$table_html .= "</table>";
	} else {
		if (isset($mlw_qmn_al_options['template']) && !empty($mlw_qmn_al_options['template'])) {
			$table_html .= "<ol class='quiz_leaderboard_wrapper'>";

			foreach ($data as $mlw_eaches) {
				$mlw_quiz_leaderboard_each = $mlw_qmn_al_options['template'];
				$mlw_quiz_leaderboard_each = str_replace("%POINT_SCORE%", $mlw_eaches->point_score, $mlw_quiz_leaderboard_each);
				$mlw_quiz_leaderboard_each = str_replace("%CORRECT_SCORE%", round($mlw_eaches->correct_score, 2), $mlw_quiz_leaderboard_each);
				$mlw_quiz_leaderboard_each = str_replace("%QUIZ_NAME%", $mlw_eaches->quiz_name, $mlw_quiz_leaderboard_each);
				$mlw_quiz_leaderboard_each = str_replace("%USER_BUSINESS%", $mlw_eaches->user_business, $mlw_quiz_leaderboard_each);
				$mlw_quiz_leaderboard_each = str_replace("%USER_NAME%", $mlw_eaches->name, $mlw_quiz_leaderboard_each);
				$mlw_quiz_leaderboard_each = str_replace("%TIME_TAKEN%", date("Y-m-d H:i", strtotime($mlw_eaches->time_taken_real)), $mlw_quiz_leaderboard_each);
				$mlw_quiz_leaderboard_each = str_replace("%AMOUNT_CORRECT%", $mlw_eaches->correct, $mlw_quiz_leaderboard_each);
				$mlw_quiz_leaderboard_each = str_replace("%TOTAL_QUESTIONS%", $mlw_eaches->total, $mlw_quiz_leaderboard_each);
				$table_html .= "<li>" . $mlw_quiz_leaderboard_each . "</li>";
			}
			$table_html .= "</ol>";
		}
	}
	$random_class = wp_generate_password();
	$table_html = "<div class='leaderboard_{$random_class}'>{$table_html}</div>";

	return $table_html;
}

function mlw_qmn_al_all_graph_shortcode($atts) {
	extract(shortcode_atts(array(
		'ranks' => 0,
		'name' => 'none',
		'max_points' => 100,
		'order' => 'score'
	), $atts));

	global $wpdb;
	$max_points = (isset($max_points) && $max_points != 0) ? $max_points : 1;
	$mlw_qmn_al_options = get_option('mlw_qmn_al_option');
	$mlw_quiz_id = isset($mlw_quiz_id) ? $mlw_quiz_id : 0;
	$mlw_quiz_options = $wpdb->get_row("SELECT * FROM `{$wpdb->prefix}mlw_quizzes` WHERE `quiz_id`='{$mlw_quiz_id}' AND `deleted`='0'");
	$serialize_options = isset($mlw_quiz_options->quiz_settings) ? unserialize($mlw_quiz_options->quiz_settings) : [];
	$quiz_options = isset($serialize_options['quiz_options']) ? unserialize($serialize_options['quiz_options']) : [];

	$mlw_order_sql = $mlw_limit_sql = '';
	if ($ranks != 0) {
		$mlw_limit_sql = " LIMIT {$ranks}";
	}
	switch ($order) {
		case 'date_asc':
			$mlw_order_sql .= " ORDER BY time_taken_real ASC";
			break;
		case 'date':
		case 'latest':
		case 'date_desc':
			$mlw_order_sql .= " ORDER BY time_taken_real DESC";
			break;
		case 'point_score':
			$mlw_order_sql .= " ORDER BY point_score DESC";
			break;
		case 'point_score_asc':
			$mlw_order_sql .= " ORDER BY point_score ASC";
			break;
		case 'score_asc':
		case 'correct_score_asc':
			$mlw_order_sql = " ORDER BY correct_score ASC";
			break;
		default:
			$mlw_order_sql = " ORDER BY correct_score DESC";
			break;
	}
	global $wpdb;
	$mlw_result_data = $wpdb->get_results("SELECT * FROM " . $wpdb->prefix . "mlw_results WHERE `deleted`='0' {$mlw_order_sql} {$mlw_limit_sql}");
	$mlw_quiz_graph_display = "<div class='quiz_graph_wrapper'>";
	if ($name != 'none') {
		$mlw_quiz_graph_display .= "<h2>" . $name . "</h2>";
	} else {
		$mlw_quiz_graph_display .= "<h2>Quiz Scores</h2>";
	}
	$mlw_quiz_graph_display .= mlw_qmn_display_graph($mlw_result_data, $order, $max_points);
	$mlw_quiz_graph_display .= "</div>";
	return $mlw_quiz_graph_display;
}

function mlw_qmn_al_single_graph_shortcode($atts) {
	extract(shortcode_atts(array(
		'mlw_quiz' => 1,
		'ranks' => 0,
		'name' => 'none',
		'max_points' => 100,
		'order' => 'score'
	), $atts));
	global $wpdb;
	$max_points = (isset($max_points) && $max_points != 0) ? $max_points : 1;
	$mlw_quiz_id = $mlw_quiz;
	$mlw_qmn_al_options = get_option('mlw_qmn_al_option');
	$mlw_quiz_options = $wpdb->get_row("SELECT * FROM `{$wpdb->prefix}mlw_quizzes` WHERE `quiz_id`='{$mlw_quiz_id}' AND `deleted`='0'");
	$serialize_options = isset($mlw_quiz_options->quiz_settings) ? unserialize($mlw_quiz_options->quiz_settings) : [];
	$quiz_options = isset($serialize_options['quiz_options']) ? unserialize($serialize_options['quiz_options']) : [];

	/**
	 * Prepare SQL
	 */
	$mlw_order_sql = $mlw_limit_sql = '';
	if ($ranks != 0) {
		$mlw_limit_sql = " LIMIT {$ranks}";
	}
	switch ($order) {
		case 'date_asc':
			$mlw_order_sql .= " ORDER BY time_taken_real ASC";
			break;
		case 'date':
		case 'latest':
		case 'date_desc':
			$mlw_order_sql .= " ORDER BY time_taken_real DESC";
			break;
		case 'point_score':
			$mlw_order_sql .= " ORDER BY point_score DESC";
			break;
		case 'point_score_asc':
			$mlw_order_sql .= " ORDER BY point_score ASC";
			break;
		case 'score_asc':
		case 'correct_score_asc':
			$mlw_order_sql = " ORDER BY correct_score ASC";
			break;
		default:
			$mlw_order_sql = " ORDER BY correct_score DESC";
			break;
	}

	global $wpdb;
	$mlw_result_data = $wpdb->get_results("SELECT * FROM " . $wpdb->prefix . "mlw_results WHERE `quiz_id`='{$mlw_quiz_id}' AND `deleted`='0' {$mlw_order_sql} {$mlw_limit_sql}");

	$mlw_quiz_graph_display = "<div class='quiz_graph_wrapper'>";
	if ($name != 'none') {
		$mlw_quiz_graph_display .= "<h2>" . $name . "</h2>";
	} else {
		$mlw_quiz_graph_display .= "<h2>" . $mlw_quiz_options->quiz_name . "</h2>";
	}
	$mlw_quiz_graph_display .= mlw_qmn_display_graph($mlw_result_data, $order, $max_points);
	$mlw_quiz_graph_display .= "</div>";
	return $mlw_quiz_graph_display;
}

function mlw_qmn_display_graph($data = array(), $order = 'latest', $max_points = 100) {
	if (empty($data)) {
		return '';
	}
	$graph_html = '';
	$mlw_qmn_al_options = get_option('mlw_qmn_al_option');

	foreach ($data as $key => $mlw_eaches) {
		$time_taken = $time_taken_ms = 0;
		$mlw_qmn_results_array = @unserialize($mlw_eaches->quiz_results);
		$mlw_complete_time = $mlw_complete_time_ms = '';
		if (is_array($mlw_qmn_results_array)) {
			$time_taken = $mlw_qmn_results_array[0];
			$hrs = $mins = $secs = $ms = "";
			$mlw_complete_hours = floor($time_taken / 3600);
			if ($mlw_complete_hours > 0) {
				$hrs = "{$mlw_complete_hours} hr";
			}
			$mlw_complete_minutes = floor(($time_taken % 3600) / 60);
			if ($mlw_complete_minutes > 0) {
				$mins = "{$mlw_complete_minutes} min";
			}
			$mlw_complete_seconds = $time_taken % 60;
			$secs = "{$mlw_complete_seconds} sec";

			$time_taken_ms = ($time_taken * 1000);
			if (isset($mlw_qmn_results_array['timer_ms']) && $mlw_qmn_results_array['timer_ms'] > 0) {
				$time_taken_ms = $mlw_qmn_results_array['timer_ms'];
				$mlw_complete_ms = floor($time_taken_ms % 1000);
				if ($mlw_complete_ms > 0) {
					$mlw_complete_ms = str_pad($mlw_complete_ms, 3, "0", STR_PAD_LEFT);
					$ms = "$mlw_complete_ms ms";
				}
			}
		}
		$data[$key]->total_time_taken = $time_taken;
		$data[$key]->total_time_taken_ms = $time_taken_ms;
		$data[$key]->total_time_taken_text = "{$hrs} {$mins} {$secs}";
		$data[$key]->total_time_taken_ms_text = "{$hrs} {$mins} {$secs} {$ms}";
	}
	switch ($order) {
		case 'date_asc':
			array_multisort(array_column($data, 'time_taken_real'), SORT_ASC, $data);
			break;
		case 'date':
		case 'latest':
		case 'date_desc':
			array_multisort(array_column($data, 'time_taken_real'), SORT_DESC, $data);
			break;
		case 'point_score':
			array_multisort(array_column($data, 'point_score'), SORT_DESC, array_column($data, 'total_time_taken_ms'), SORT_ASC, $data);
			break;
		case 'point_score_asc':
			array_multisort(array_column($data, 'point_score'), SORT_ASC, array_column($data, 'total_time_taken_ms'), SORT_DESC, $data);
			break;
		case 'time_taken':
			array_multisort(array_column($data, 'total_time_taken'), SORT_ASC, array_column($data, 'total_time_taken_ms'), SORT_ASC, $data);
			break;
		case 'time_taken_desc':
			array_multisort(array_column($data, 'total_time_taken'), SORT_DESC, array_column($data, 'total_time_taken_ms'), SORT_DESC, $data);
			break;
		case 'score_asc':
		case 'correct_score_asc':
			array_multisort(array_column($data, 'correct_score'), SORT_ASC, array_column($data, 'total_time_taken_ms'), SORT_DESC, $data);
			break;
		default:
			array_multisort(array_column($data, 'correct_score'), SORT_DESC, array_column($data, 'total_time_taken_ms'), SORT_ASC, $data);
			break;
	}
	$graph_html = "<ul class='mlw_shortcode_bargraph'>";
	foreach ($data as $key => $mlw_eaches) {
		$mlw_quiz_leaderboard_each = $mlw_qmn_al_options['template'];
		$mlw_quiz_leaderboard_each = str_replace("%POINT_SCORE%", $mlw_eaches->point_score, $mlw_quiz_leaderboard_each);
		$mlw_quiz_leaderboard_each = str_replace("%CORRECT_SCORE%", round($mlw_eaches->correct_score, 2), $mlw_quiz_leaderboard_each);
		$mlw_quiz_leaderboard_each = str_replace("%QUIZ_NAME%", $mlw_eaches->quiz_name, $mlw_quiz_leaderboard_each);
		$mlw_quiz_leaderboard_each = str_replace("%USER_NAME%", $mlw_eaches->name, $mlw_quiz_leaderboard_each);
		$mlw_quiz_leaderboard_each = str_replace("%USER_EMAIL%", $mlw_eaches->email, $mlw_quiz_leaderboard_each);
		$mlw_quiz_leaderboard_each = str_replace("%TIME_TAKEN%", $mlw_eaches->total_time_taken_text, $mlw_quiz_leaderboard_each);
		$mlw_quiz_leaderboard_each = str_replace("%TIME_TAKEN_MS%", $mlw_eaches->total_time_taken_ms_text, $mlw_quiz_leaderboard_each);
		$mlw_quiz_leaderboard_each = str_replace("%AMOUNT_CORRECT%", $mlw_eaches->correct, $mlw_quiz_leaderboard_each);
		$mlw_quiz_leaderboard_each = str_replace("%TOTAL_QUESTIONS%", $mlw_eaches->total, $mlw_quiz_leaderboard_each);

		if ($mlw_eaches->quiz_system == 0) {
			if ($mlw_eaches->correct_score < 15) {
				$graph_html .= "<li style=\"width: 15%;\">" . $mlw_quiz_leaderboard_each . "</li>";
			} else {
				$graph_html .= "<li style=\"width: " . $mlw_eaches->correct_score . "%;\">" . $mlw_quiz_leaderboard_each . "</li>";
			}
		} elseif ($mlw_eaches->quiz_system == 1) {
			$mlw_style_width = ($mlw_eaches->point_score / $max_points) * 100;
			if ($mlw_style_width < 15) {
				$graph_html .= "<li style=\"width: 15%;\">" . $mlw_quiz_leaderboard_each . "</li>";
			} else {
				$graph_html .= "<li style=\"width: " . $mlw_style_width . "%;\">" . $mlw_quiz_leaderboard_each . "</li>";
			}
		} else {
			if ($mlw_eaches->correct_score < 15) {
				$graph_html .= "<li style=\"width: 15%;\">" . $mlw_quiz_leaderboard_each . "</li>";
			} else {
				$graph_html .= "<li style=\"width: " . $mlw_eaches->correct_score . "%;\">" . $mlw_quiz_leaderboard_each . "</li>";
			}
		}
	}
	$graph_html .= "</ul>";
	return $graph_html;
}
